import * as i0 from '@angular/core';
import { Component, EventEmitter, ChangeDetectionStrategy, Inject, Input, Output, ViewChild, ContentChildren, Injectable, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import * as i2 from '@angular/platform-browser';
import { HAMMER_GESTURE_CONFIG, HammerGestureConfig } from '@angular/platform-browser';
import * as Hammer from 'hammerjs';
import * as i1 from '@ionic/angular';

class IonicPullupComponentTabComponent {
}
/** @nocollapse */ IonicPullupComponentTabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupComponentTabComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ IonicPullupComponentTabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: IonicPullupComponentTabComponent, selector: "lib-ionic-pullup-tab", ngImport: i0, template: "<ng-content></ng-content>", styles: [":host{z-index:1000;display:flex;justify-content:center;position:relative;width:120px;height:10px;background:var(--ion-color-primary);color:#fff;border-radius:10px 10px 0 0;margin:0 auto}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupComponentTabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-ionic-pullup-tab', template: "<ng-content></ng-content>", styles: [":host{z-index:1000;display:flex;justify-content:center;position:relative;width:120px;height:10px;background:var(--ion-color-primary);color:#fff;border-radius:10px 10px 0 0;margin:0 auto}\n"] }]
        }] });

/*
ionic-pullup v4 for Ionic 4 and Angular 8

Copyright 2020 Ariel Faur (https://github.com/arielfaur)
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
    http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var IonPullUpFooterState;
(function (IonPullUpFooterState) {
    IonPullUpFooterState[IonPullUpFooterState["Collapsed"] = 0] = "Collapsed";
    IonPullUpFooterState[IonPullUpFooterState["Expanded"] = 1] = "Expanded";
    IonPullUpFooterState[IonPullUpFooterState["Minimized"] = 2] = "Minimized";
})(IonPullUpFooterState || (IonPullUpFooterState = {}));
var IonPullUpFooterBehavior;
(function (IonPullUpFooterBehavior) {
    IonPullUpFooterBehavior[IonPullUpFooterBehavior["Hide"] = 0] = "Hide";
    IonPullUpFooterBehavior[IonPullUpFooterBehavior["Expand"] = 1] = "Expand";
})(IonPullUpFooterBehavior || (IonPullUpFooterBehavior = {}));
class IonicPullupComponent {
    constructor(platform, renderer, hammerConfig) {
        var _a, _b;
        this.platform = platform;
        this.renderer = renderer;
        this.hammerConfig = hammerConfig;
        this.stateChange = new EventEmitter();
        /**
         *  Maximum expanded position - useful if there are top headers
         *  If not provided by default computes available screen minus tabs and headers
         */
        this.toolbarTopMargin = 0;
        /**
         *  Minimum position - useful to keep a part of the footer always visible at the bottom
         */
        this.minBottomVisible = 0;
        this.expanded = new EventEmitter();
        this.collapsed = new EventEmitter();
        this.minimized = new EventEmitter();
        /**
         * Outputs the amount of pixels the user has dragged positive or negative
         */
        this.dragged = new EventEmitter();
        this.footerMeta = {
            height: 0,
            posY: 0,
            lastPosY: 0
        };
        this.currentViewMeta = { bottomSpace: screen.height - window.innerHeight };
        // sets initial state
        this.initialState = (_a = this.initialState) !== null && _a !== void 0 ? _a : IonPullUpFooterState.Collapsed;
        this.defaultBehavior = (_b = this.defaultBehavior) !== null && _b !== void 0 ? _b : IonPullUpFooterBehavior.Expand;
    }
    get expandedHeight() {
        return window.innerHeight - this.currentViewMeta.toolbarHeight - this.currentViewMeta.tabsHeight;
    }
    ngOnInit() {
        // console.debug('ionic-pullup => Initializing footer...');
        window.addEventListener('orientationchange', () => {
            // console.debug('ionic-pullup => Changed orientation => updating');
            this.updateUI();
            this.collapse();
        });
        this.platform.resume.subscribe(() => {
            // console.debug('ionic-pullup => Resumed from background => updating');
            this.updateUI();
            this.collapse();
        });
        // compute min boundary of toolbar depending on whether drawer is dockable
        this.footerMeta.toolbarLowerBoundary = this.dockable ? this.minBottomVisible : 0;
    }
    ngAfterContentInit() {
        this.computeDefaults();
        this.state = IonPullUpFooterState.Collapsed;
        this.updateUI();
    }
    computeDefaults() {
        setTimeout(() => {
            this.footerMeta.toolbarDefaultHeight = this.childFooter.nativeElement.offsetHeight;
            this.findIonicComponentsInPage();
            this.dragElements.forEach(elem => {
                const hammer = this.hammerConfig.buildHammer(elem.el);
                hammer.on('pan panstart panend', (ev) => {
                    this.onPan(ev);
                });
            });
        }, 300);
    }
    computeHeights() {
        this.footerMeta.height = this.expandedHeight;
        this.footerMeta.toolbarDefaultExpandedPosition = -this.footerMeta.height + this.footerMeta.toolbarDefaultHeight + this.minBottomVisible;
        this.footerMeta.toolbarUpperBoundary = this.footerMeta.height - this.footerMeta.toolbarDefaultHeight - this.minBottomVisible;
        this.renderer.setStyle(this.childFooter.nativeElement, 'height', this.footerMeta.height + 'px');
        this.renderer.setStyle(this.childFooter.nativeElement, 'top', `${window.innerHeight - this.footerMeta.toolbarDefaultHeight - this.currentViewMeta.tabsHeight - this.minBottomVisible}px`);
        this.updateIonContentHeight();
        // TODO check if this is needed for native platform iOS/Android
        // this.renderer.setStyle(this.childFooter.nativeElement, 'bottom', this.currentViewMeta.tabsHeight + 'px');
    }
    updateUI(isInit = false) {
        if (!this.childFooter) {
            return;
        }
        setTimeout(() => {
            this.computeHeights();
        }, 300);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none'); // avoids flickering when changing orientation
    }
    expand() {
        this.footerMeta.lastPosY = this.footerMeta.toolbarDefaultExpandedPosition;
        // reset ionContent scaling
        this.updateIonContentHeight(this.minBottomVisible - this.footerMeta.lastPosY);
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
        this.expanded.emit(null);
    }
    collapse(isInit = false) {
        if (!this.childFooter) {
            return;
        }
        this.footerMeta.lastPosY = 0;
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', `translate3d(0, ${this.footerMeta.lastPosY}px, 0)`);
        // reset ionContent scaling -> needs 300ms timeout to delay content resize
        setTimeout(() => this.updateIonContentHeight(this.minBottomVisible - this.footerMeta.lastPosY), 300);
        if (!isInit) {
            this.collapsed.emit(null);
        }
    }
    /**
     * TODO
     */
    minimize() {
        this.footerMeta.lastPosY = this.footerMeta.height;
        this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.lastPosY + 'px, 0)');
        this.minimized.emit(null);
    }
    onTap(e) {
        e.preventDefault();
        if (this.state === IonPullUpFooterState.Collapsed) {
            if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                this.state = IonPullUpFooterState.Minimized;
            }
            else {
                this.state = IonPullUpFooterState.Expanded;
            }
        }
        else {
            if (this.state === IonPullUpFooterState.Minimized) {
                if (this.defaultBehavior === IonPullUpFooterBehavior.Hide) {
                    this.state = IonPullUpFooterState.Collapsed;
                }
                else {
                    this.state = IonPullUpFooterState.Expanded;
                }
            }
            else {
                // footer is expanded
                this.state = this.initialState === IonPullUpFooterState.Minimized ? IonPullUpFooterState.Minimized : IonPullUpFooterState.Collapsed;
            }
        }
    }
    onPan(e) {
        this.renderer.setStyle(this.childFooter.nativeElement, 'transition', 'none');
        e.preventDefault();
        switch (e.type) {
            case 'pan':
                this.footerMeta.posY = e.deltaY + this.footerMeta.lastPosY;
                // check for min and max boundaries of draggable toolbar
                this.footerMeta.posY = this.footerMeta.posY > this.footerMeta.toolbarLowerBoundary ? this.footerMeta.toolbarLowerBoundary :
                    (Math.abs(this.footerMeta.posY) > this.footerMeta.toolbarUpperBoundary ?
                        this.footerMeta.toolbarDefaultExpandedPosition :
                        this.footerMeta.posY);
                // ionContent scaling - FIX scrolling bug
                this.updateIonContentHeight(this.minBottomVisible - this.footerMeta.posY);
                this.renderer.setStyle(this.childFooter.nativeElement, '-webkit-transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                this.renderer.setStyle(this.childFooter.nativeElement, 'transform', 'translate3d(0, ' + this.footerMeta.posY + 'px, 0)');
                break;
            case 'panend':
                this.renderer.setStyle(this.childFooter.nativeElement, 'transition', '300ms ease-in-out');
                this.footerMeta.lastPosY = this.footerMeta.posY;
                // ionContent scaling - FIX scrolling bug
                this.updateIonContentHeight(this.minBottomVisible - this.footerMeta.lastPosY);
                // emit last footer position after dragging ends
                const handle = this.dragElements.first;
                this.dragged.emit({
                    delta: this.footerMeta.lastPosY,
                    toolbarAbsolutePosition: handle ? handle.el.getBoundingClientRect() : null
                });
                // TODO auto dock
                // if (this.footerMeta.lastPosY > this.footerMeta.height - this.footerMeta.defaultHeight) {
                //   this.state =  IonPullUpFooterState.Collapsed;
                // }
                break;
        }
    }
    ngOnChanges(changes) {
        var _a, _b, _c, _d;
        if ((_b = (_a = changes.state) === null || _a === void 0 ? void 0 : _a.firstChange) !== null && _b !== void 0 ? _b : ((_c = changes.state) === null || _c === void 0 ? void 0 : _c.currentValue) === ((_d = changes.state) === null || _d === void 0 ? void 0 : _d.previousValue)) {
            return;
        }
        switch (this.state) {
            case IonPullUpFooterState.Collapsed:
                this.collapse();
                break;
            case IonPullUpFooterState.Expanded:
                this.expand();
                break;
            case IonPullUpFooterState.Minimized:
                this.minimize();
                break;
        }
        // TODO: fix hack due to BUG (https://github.com/angular/angular/issues/6005)
        window.setTimeout(() => {
            this.stateChange.emit(this.state);
        });
    }
    /**
     * Detect ionic components in page
     */
    findIonicComponentsInPage() {
        this.footerMeta.ionContentRef = this.childFooter.nativeElement.querySelector('ion-content');
        this.currentViewMeta.tabsRef = document.querySelector('ion-tab-bar');
        this.currentViewMeta.tabsHeight = this.currentViewMeta.tabsRef ? this.currentViewMeta.tabsRef.offsetHeight : 0;
        // console.debug(this.currentViewMeta.tabsRef ? 'ionic-pullup => Tabs detected' : 'ionic.pullup => View has no tabs');
        if (!this.toolbarTopMargin) {
            const outletRef = document.querySelector('ion-router-outlet');
            if (outletRef) {
                const headerRef = outletRef.querySelector('ion-header');
                if (headerRef) {
                    this.currentViewMeta.toolbarRef = headerRef.querySelector('ion-toolbar');
                    this.currentViewMeta.toolbarHeight = this.currentViewMeta.toolbarRef.clientHeight;
                    // console.debug(this.currentViewMeta.toolbarRef ? `ionic-pullup => Toolbar detected` : 'ionic.pullup => View has no tabs');
                }
                else {
                    this.currentViewMeta.toolbarHeight = 0;
                }
            }
        }
        else {
            this.currentViewMeta.toolbarHeight = this.toolbarTopMargin;
        }
    }
    /**
     * Update inner ion-content component height when footer is expanded, collapsed or dragged
     *
     * @param maxHeight maximum ionContent height to set
     */
    updateIonContentHeight(maxHeight) {
        if (!this.footerMeta.ionContentRef) {
            return;
        }
        const maxHeightUnits = maxHeight ? `${maxHeight}px` : (this.minBottomVisible > 0 ? `${this.minBottomVisible}px` : '100%');
        this.renderer.setStyle(this.footerMeta.ionContentRef, 'max-height', maxHeightUnits);
    }
}
/** @nocollapse */ IonicPullupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupComponent, deps: [{ token: i1.Platform }, { token: i0.Renderer2 }, { token: HAMMER_GESTURE_CONFIG }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ IonicPullupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: IonicPullupComponent, selector: "lib-ionic-pullup", inputs: { state: "state", initialState: "initialState", defaultBehavior: "defaultBehavior", toolbarTopMargin: "toolbarTopMargin", minBottomVisible: "minBottomVisible", dockable: "dockable" }, outputs: { stateChange: "stateChange", expanded: "expanded", collapsed: "collapsed", minimized: "minimized", dragged: "dragged" }, queries: [{ propertyName: "dragElements", predicate: ["ionDragFooter"] }], viewQueries: [{ propertyName: "childFooter", first: true, predicate: ["footer"], descendants: true, static: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"footer\" #footer>\n  <ng-content></ng-content>\n</div>", styles: [".footer{left:0px;right:0px;position:fixed;z-index:999}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-ionic-pullup', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"footer\" #footer>\n  <ng-content></ng-content>\n</div>", styles: [".footer{left:0px;right:0px;position:fixed;z-index:999}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i1.Platform }, { type: i0.Renderer2 }, { type: i2.HammerGestureConfig, decorators: [{
                        type: Inject,
                        args: [HAMMER_GESTURE_CONFIG]
                    }] }];
    }, propDecorators: { state: [{
                type: Input
            }], stateChange: [{
                type: Output
            }], initialState: [{
                type: Input
            }], defaultBehavior: [{
                type: Input
            }], toolbarTopMargin: [{
                type: Input
            }], minBottomVisible: [{
                type: Input
            }], dockable: [{
                type: Input
            }], expanded: [{
                type: Output
            }], collapsed: [{
                type: Output
            }], minimized: [{
                type: Output
            }], dragged: [{
                type: Output
            }], childFooter: [{
                type: ViewChild,
                args: ['footer', { static: true }]
            }], dragElements: [{
                type: ContentChildren,
                args: ['ionDragFooter']
            }] } });

class MyHammerConfig extends HammerGestureConfig {
    constructor() {
        super(...arguments);
        this.overrides = {
            pan: { direction: Hammer.DIRECTION_VERTICAL },
        };
    }
}
/** @nocollapse */ MyHammerConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: MyHammerConfig, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
/** @nocollapse */ MyHammerConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: MyHammerConfig });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: MyHammerConfig, decorators: [{
            type: Injectable
        }] });
class IonicPullupModule {
}
/** @nocollapse */ IonicPullupModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
/** @nocollapse */ IonicPullupModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupModule, declarations: [IonicPullupComponent, IonicPullupComponentTabComponent], exports: [IonicPullupComponent, IonicPullupComponentTabComponent] });
/** @nocollapse */ IonicPullupModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupModule, providers: [
        {
            provide: HAMMER_GESTURE_CONFIG,
            useClass: MyHammerConfig,
        },
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: IonicPullupModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [IonicPullupComponent, IonicPullupComponentTabComponent],
                    imports: [],
                    exports: [IonicPullupComponent, IonicPullupComponentTabComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                    providers: [
                        {
                            provide: HAMMER_GESTURE_CONFIG,
                            useClass: MyHammerConfig,
                        },
                    ]
                }]
        }] });

/*
 * Public API Surface of ionic-pullup
 */

/**
 * Generated bundle index. Do not edit.
 */

export { IonPullUpFooterBehavior, IonPullUpFooterState, IonicPullupComponent, IonicPullupComponentTabComponent, IonicPullupModule, MyHammerConfig };
//# sourceMappingURL=ionic-pullup.mjs.map
